{
   Eine einzufügende Form, um damit die Console zu ersetzen

   in der HauptForm nur die beiden Buttons mit entspr. Click-Prozedur
      OpenEventsButton
      ShowEventsButton
   hinzufügen
   und zur Ausgabe in die Memo Eventln(s:string) bzw WatchLn(s:string)

   und bei FormDestroy noch hinzufügen:
           if EventOpenStatus = eoOpen then
              eventform.close

      (Gibt es eine andere Möglichkeit, um festzustellen, ob eine Form
       schon erstellt worden ist?)
}
type TEventform=class(TForm)
  EventsWrapButton: TButton;
  EventsWritePermitButton: TButton;
  EventsClearButton: TSpeedButton;
  events: TMemo;
  procedure EventsWrapButtonClick(Sender: TObject); // Zeilenumbruch?
  procedure EventsWritePermitButtonClick(Sender: TObject); // in Memo schreiben?
  procedure EventsClearButtonClick(Sender: TObject); // Memo löschen

  procedure EventFormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure EventFormResize(Sender: TObject);

  procedure EventFormCreate(Sender: TObject);
  procedure EventFormClose(Sender: TObject; var CloseAction: TCloseAction);
  procedure EventFormDestroy(Sender: TObject);

  constructor createNew(TheOwner: TComponent);
  end;



var eventform:TEventform;
    WritePermit:boolean;
      { damit kann man in die Memo auch schreiben, Text auswählen, löschen,
        verschieben etc. }

    EventsRect: TRect;   // zum Speichern der EventForm-Größe und -Position

 const
    EventsOpenStatus: (eoOpen, eoClosed) = eoClosed;
    EventsButtonstr:array[0..4] of string =
      ('Wrap', 'No Wrap', 'Writing', 'No Writing', 'Clear');
    OpenShowEventsStr: array[0..3] of string =
      ('Close Events', 'Open Events', 'Hide Events', 'Show Events');

const maxevent:integer = 500; // maximale Zeilenanzahl in der Memo

procedure TeventForm.EventsWrapButtonClick(Sender: TObject);
  begin with events do
    begin wordwrap:= not wordwrap;
       EventsWrapButton.caption:=EventsButtonStr[byte(wordwrap)];
    end;
  end;
procedure TEventForm.EventsWritePermitButtonClick(Sender: TObject);
  begin WritePermit := not WritePermit;
    EventsWritePermitButton.caption := EventsButtonStr[2+byte(WritePermit)];
  end;
procedure TeventForm.EventsClearButtonClick(Sender: TObject);
  begin
    events.lines.clear;
  end;

procedure TEventForm.EventFormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not WritePermit then key:=0; // => keine Tastatureingaben in der Memo!
end;
procedure TEventForm.EventFormResize(Sender: TObject);
  begin
     events.Height:=height-50;
  end;

constructor TEventForm.createNew(TheOwner: TComponent);
 begin
     inherited createNew(TheOwner);
 end;
procedure TEventform.EventFormCreate(Sender: TObject);
  begin
      eventform:=TEventform.CreateNew(nil);
           // createnew, weil in der lpr-Datei angegeben ist
           //   RequireDerivedFormResource := True;
    with eventform do
      begin
        BoundsRect:=EventsRect;
        borderstyle := bsSizeable; Caption:='Events';
        show;
        onClose:=@EventFormClose;
        onResize:=@EventFormResize;
    Events:=TMemo.create(self);
      with Events do
        begin
          Parent:=eventform;
          Align:=albottom;
          ScrollBars:=ssAutoBoth;
          height:=eventform.height-50;
          OnKeyDown := @EventFormKeyDown; // um evtl. Texteingaben zu unterbinden
          show;
        end;
    EventsWrapButton:=TButton.Create(eventform);
      with EventsWrapButton do
        begin
             parent:=eventform;
             setbounds(20,10,75, 30);
             caption := EventsButtonStr[byte(events.wordwrap)];
             onclick:=@EventsWrapButtonclick;
              show;
        end;
    EventsWritePermitButton:=TButton.Create(eventform);
      with EventsWritePermitButton do
        begin
             parent:=eventform;
             setbounds(100,10,75, 30);
             caption := EventsButtonStr[2+byte(WritePermit)];
             onclick:=@EventsWritePermitButtonclick;
              show;
        end;
    EventsClearButton :=TSpeedButton.Create(self);
      with EventsClearButton do
        begin
          parent:=eventform;
          setbounds(180,10,75,30);
          caption := EventsButtonStr[4];
          onclick:=@EventsClearButtonClick;
          show;
        end;
      end;
  end;
procedure TEventForm.EventFormClose(Sender: TObject; var CloseAction: TCloseAction);
  begin
    EventsRect:= BoundsRect; // Formsize speichern
    mainform.OpenEventsButton.caption:=OpenShowEventsstr[1];
    mainform.ShowEventsButton.Caption:=OpenShowEventsstr[3];
    EventsOpenStatus := eoClosed;
  end;

procedure TEventForm.EventFormDestroy(Sender: TObject);
  begin
    Events.free;
    EventsWritePermitButton.free;
    EventsClearButton.free;
    EventsWrapButton.free;
    close;
    //
  end;


procedure OpenEvents(Sender: TObject);
   begin
     eventform.EventFormCreate(Sender); EventsOpenStatus:=eoOpen;
     mainform.OpenEventsButton.caption:=OpenShowEventsstr[0]; // Close
     mainform.ShowEventsButton.Caption:=OpenShowEventsstr[2];  // Hide
   end;
procedure CloseEvents(Sender: TObject);
   begin
     eventform.EventFormDestroy(Sender); EventsOpenStatus:=eoClosed;
    mainform.OpenEventsButton.caption:=OpenShowEventsstr[1];  // Open
    mainform.ShowEventsButton.Caption:=OpenShowEventsstr[3];  // Show
   end;

procedure ToggleOpenEvents(Sender:TObject);
begin
  if EventsOpenStatus = eoClosed then
      OpenEvents(Sender) else
      CloseEvents(Sender);
end;

procedure ToggleShowEvents(Sender: TObject);
 begin
   if EventsOpenStatus = eoClosed then
          OpenEvents(Sender) else
   with eventform do
   begin visible:=not visible;
        mainform.ShowEventsButton.Caption:=OpenShowEventsstr[2+byte(not visible)];
   end;
 end  ;


{###########################################################

  Aufrufe aus dem HauptProgramm:

}

const events_Zeigen: boolean=true;

procedure TMainForm.EventLn(s:string);
  begin if events_zeigen then if EventsOpenStatus = eoOpen then
     with eventform.events.lines do
            begin Add(s); if count > maxevent then delete(0); end
  end;


procedure TMainForm.WatchLn(s:string);
  begin  if EventsOpenStatus = eoOpen then
     with eventform.events.lines do
            begin Add(s); if count > maxevent then delete(0); end
  end;


procedure TMainForm.OpenEventsButtonClick(Sender: TObject);
  begin
      ToggleOpenEvents(Sender);
  end;
procedure TMainForm.ShowEventsButtonClick(Sender: TObject);
  begin
    ToggleShowEvents(Sender);
  end;




